Bug 1259002 - Review Request: rudiments - C++ class library for developing systems and applications
Review Request: rudiments - C++ class library for developing systems and appl...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Kevin Fenzi
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-NEEDSPONSOR
  Show dependency treegraph
 
Reported: 2015-09-01 13:26 EDT by David Muse
Modified: 2016-12-24 22:20 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-24 22:20:52 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
kevin: fedora‑review+


Attachments (Terms of Use)
proposed rudiments.spec-patch (1.79 KB, patch)
2015-09-17 01:29 EDT, Jens Lody
no flags Details | Diff
licensecheck.txt (21.96 KB, text/plain)
2015-09-17 01:33 EDT, Jens Lody
no flags Details

  None (edit)
Description David Muse 2015-09-01 13:26:57 EDT
Spec URL: http://rudiments.sourceforge.net/rpm/rudiments.spec
SRPM URL: http://rudiments.sourceforge.net/rpm/rudiments-0.53-1.fc22.src.rpm
Description: A C++ class library for developing systems and applications.
Fedora Account System Username: davidleemuse

Rudiments is the base library for SQL Relay and a few other projects of mine.

This is my first package, and I need a sponsor.

Here's a link to a successful Koji build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=10915810
Comment 1 Jens Lody 2015-09-11 05:01:59 EDT
The package does not build in fedora-review:

commandline:

fedora-review -m fedora-rawhide-x86_64 -b 1259002

error:

<snip>
/bin/sh ../libtool --mode=compile g++ -O2 -g -pipe   -mtune=generic -pipe  -Wall -Werror    -D_REENTRANT -D_THREAD_SAFE -D__EXTENSIONS__     -I../ -I../include -DINCLUDE_INETCLIENT -DINCLUDE_INETSERVER -DINCLUDE_UNIXCLIENT -DINCLUDE_UNIXSERVER -c directory.cpp -o directory.lo
libtool: compile:  g++ -O2 -g -pipe -mtune=generic -pipe -Wall -Werror -D_REENTRANT -D_THREAD_SAFE -D__EXTENSIONS__ -I../ -I../include -DINCLUDE_INETCLIENT -DINCLUDE_INETSERVER -DINCLUDE_UNIXCLIENT -DINCLUDE_UNIXSERVER -c directory.cpp  -fPIC -DPIC -o .libs/directory.o
directory.cpp:332:6: error: #error no mkdir or anything like it
     #error no mkdir or anything like it
      ^
directory.cpp:341:5: error: #error no mkdir or anything like it
    #error no mkdir or anything like it
     ^
directory.cpp: In static member function 'static bool directory::create(const char*, mode_t)':
directory.cpp:344:1: error: no return statement in function returning non-void [-Werror=return-type]
 }
 ^
cc1plus: all warnings being treated as errors
</snip>
Comment 2 Jens Lody 2015-09-11 05:30:04 EDT
Besides this:

%clean can normally be removed,
rm -rf %buildroot is deprecated,
%defattr(-, root, root) also.

%{_datadir}/licenses/%{name} is unneeded as far as I know.

The descriptions just repeats the summary, is it possible to be more elaborately.
Comment 3 David Muse 2015-09-12 01:25:11 EDT
* %clean removed
* rm -rf %buildroot removed
* defattr removed
* %{_datadir}/licenses/%{name} removed
* updated summary
* added configure script patch for f23/f24

f24 build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=11057764

f23 build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=11057686

f22 build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=11057918
Comment 5 Jens Lody 2015-09-17 01:29:37 EDT
Created attachment 1074268 [details]
proposed rudiments.spec-patch

I attached a proposed patch for the spec-file, that creates a doc subpackage (large documentation) and finally fremoves the "rm -rf %{buildroot}"-call.
I also fixed the sourceforge-url, so it works (again?).
rpmlints spits out a false positive "only-non-binary-in-usr-lib"-error due to the *.so.symlink.
I changed the explicit *.so.*-names to  "%{_libdir}/librudiments-%{version}.so.*" in %files-section, so it can handle newer revisions also.
Comment 6 Jens Lody 2015-09-17 01:33:27 EDT
Created attachment 1074270 [details]
licensecheck.txt

I saw you are also upstream, so you should consider to update the COPYING-file to a recent LGPL, yours is quite old.

You should also fix the incorrect fsf-address upstream and mention the different licennse versions in the License-tag see: https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#Multiple_Licensing_Scenarios .

By the way: I forgot in my previous post the explicit docdir= in %install is unneeded, I also removed it in my proposed patch.
Comment 7 Jens Lody 2015-09-17 01:34:30 EDT
Still just informal and just a quick look, I hope I find the time to dig deeper into it soon.
Comment 8 Kevin Fenzi 2015-09-20 11:50:45 EDT
Hey David. I would be happy to review this and sponsor you. Could you look at addressing the issues/feedback Jens noted and post an updated spec/srpm for review? Thanks.
Comment 9 Upstream Release Monitoring 2015-09-25 01:15:02 EDT
davidleemuse's scratch build of rudiments-0.53-4.fc22.src.rpm for f22 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11221591
Comment 10 David Muse 2015-09-25 01:53:09 EDT
updates:
* applied Jens' patch
* updated fsf address in 2 files where it was wrong
* updated COPYING and spec to be very specific about what licenses different parts of the distribution are covered by - mainly LGPL, various other files covered by GPL, example code covered by FSF Unlimited License (FSFUL).

Updated Spec: http://rudiments.sourceforge.net/rpm/rudiments.spec
Updated SRPM: http://rudiments.sourceforge.net/rpm/rudiments-0.53-4.fc22.src.rpm

f22 build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=11221591

f23 build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=11221664

f24 build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=11221780


Is an update to a newer version of the LGPL required for a successful review?

If so, I'll look into it.  I've considered updating to a newer version of the LGPL before though.  The legal nuances between the different versions are daunting to analyze and Rudiments has been covered by LGPL2 for 15 years without incident.
Comment 11 Kevin Fenzi 2015-09-27 14:30:13 EDT
So, you don't really need to mention the test and build scripts licenses. 
You want to list the license of the files in the binary packages. 
https://fedoraproject.org/wiki/Licensing:FAQ?rd=Licensing/FAQ#Does_the_License:_tag_cover_the_SRPM_or_the_binary_RPM.3F

There's no need to change license version, LGPLv2 is fine, you just want to update the LGPLv2 COPYING file (they updated it when the fsf moved mailing addresses). 

One other minor thing I noticed from a prelim bit of testing:

rudiments.x86_64: W: unused-direct-shlib-dependency /usr/lib64/librudiments-0.53.so.1.0.0 /lib64/libm.so.6

perhaps you don't need to link -lm? 

I'll go ahead and take this for review now, look for a full review a bit later hopefully today. ;)
Comment 12 Kevin Fenzi 2015-09-27 14:50:35 EDT
None of the issues I see are blocking, so I have sponsored you into the packager group and approved this review. However, if you could take a look at the non-blocking issues before importing that would be great. 

You should be able to continue the process from: 
https://fedoraproject.org/wiki/Join_the_package_collection_maintainers?rd=PackageMaintainers/Join#Add_Package_to_Source_Code_Management_.28SCM.29_system_and_Set_Owner

If you have any questions at all, please don't hesitate to ask me in private email, here, on the devel list or on irc in #fedora-devel. 

Welcome to the fun!

Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines
IGNORE: This seems to be a fedora-review bug where it's trying to install 
the debuginfo package twice. No actual issue here.

- non blocker: Perhaps the doc subpackage could be made noarch and not depend on 
the main package? (Also would need a copy of the license then). 
That would save space on mirrors and allow people to install the 
docs without needing to install the base package. 

- non blocker: Could you add comments for the patches in the spec 
file? If they have been submitted upstream/why they are needed?

- non blocker: Check the linking to -lm and remove if unneeded.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v2.1 or later)", "GPL (v2 or later)", "Unknown or
     generated". 492 files have unknown license. Detailed output of
     licensecheck in /home/fedora/kevin/1259002-rudiments/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 51200 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Scriptlets must be sane, if used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[!]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 10629120 bytes in /usr/share
     rudiments-doc-0.53-4.fc24.x86_64.rpm:10516480
     See:
     http://fedoraproject.org/wiki/Packaging:ReviewGuidelines#Package_Review_Guidelines
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.2.13 starting (python version = 3.4.3)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled ccache
Mock Version: 1.2.13
INFO: Mock Version: 1.2.13
Finish: chroot init
INFO: installing package(s): /home/fedora/kevin/1259002-rudiments/results/rudiments-0.53-4.fc24.x86_64.rpm /home/fedora/kevin/1259002-rudiments/results/rudiments-devel-0.53-4.fc24.x86_64.rpm /home/fedora/kevin/1259002-rudiments/results/rudiments-doc-0.53-4.fc24.x86_64.rpm /home/fedora/kevin/1259002-rudiments/results/rudiments-debuginfo-0.53-4.fc24.x86_64.rpm /home/fedora/kevin/1259002-rudiments/results/rudiments-debuginfo-0.53-4.fc24.x86_64.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 24 install /home/fedora/kevin/1259002-rudiments/results/rudiments-0.53-4.fc24.x86_64.rpm /home/fedora/kevin/1259002-rudiments/results/rudiments-devel-0.53-4.fc24.x86_64.rpm /home/fedora/kevin/1259002-rudiments/results/rudiments-doc-0.53-4.fc24.x86_64.rpm /home/fedora/kevin/1259002-rudiments/results/rudiments-debuginfo-0.53-4.fc24.x86_64.rpm /home/fedora/kevin/1259002-rudiments/results/rudiments-debuginfo-0.53-4.fc24.x86_64.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: rudiments-0.53-4.fc24.x86_64.rpm
          rudiments-devel-0.53-4.fc24.x86_64.rpm
          rudiments-doc-0.53-4.fc24.x86_64.rpm
          rudiments-debuginfo-0.53-4.fc24.x86_64.rpm
          rudiments-0.53-4.fc24.src.rpm
rudiments.x86_64: W: spelling-error %description -l en_US parsers -> parser, parses, parers
rudiments-devel.x86_64: W: only-non-binary-in-usr-lib
rudiments.src: W: spelling-error %description -l en_US parsers -> parser, parses, parers
5 packages and 0 specfiles checked; 0 errors, 3 warnings.




Requires
--------
rudiments (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libcrypt.so.1()(64bit)
    libcrypto.so.10()(64bit)
    libcrypto.so.10(libcrypto.so.10)(64bit)
    libdl.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpcre.so.1()(64bit)
    libpthread.so.0()(64bit)
    libssl.so.10()(64bit)
    libssl.so.10(libssl.so.10)(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)

rudiments-doc (rpmlib, GLIBC filtered):
    rudiments(x86-64)

rudiments-debuginfo (rpmlib, GLIBC filtered):

rudiments-devel (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/pkg-config
    librudiments-0.53.so.1()(64bit)
    rudiments(x86-64)



Provides
--------
rudiments:
    librudiments-0.53.so.1()(64bit)
    rudiments
    rudiments(x86-64)

rudiments-doc:
    rudiments-doc
    rudiments-doc(x86-64)

rudiments-debuginfo:
    rudiments-debuginfo
    rudiments-debuginfo(x86-64)

rudiments-devel:
    pkgconfig(rudiments)
    rudiments-devel
    rudiments-devel(x86-64)



Source checksums
----------------
http://downloads.sourceforge.net/rudiments/rudiments-0.53.tar.gz :
  CHECKSUM(SHA256) this package     : befa05319a431da4a6dbbcae0a590d4d53274ea2776c4b3980c1672a6e7ac0c8
  CHECKSUM(SHA256) upstream package : befa05319a431da4a6dbbcae0a590d4d53274ea2776c4b3980c1672a6e7ac0c8


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1259002
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 13 Gwyn Ciesla 2015-11-11 22:11:40 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rudiments
Comment 14 Fedora Update System 2015-11-12 13:38:21 EST
rudiments-0.53-4.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-a87ff17999
Comment 15 Fedora Update System 2015-11-12 13:42:01 EST
rudiments-0.53-4.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-c816143d56
Comment 16 Fedora Update System 2015-11-12 23:23:39 EST
rudiments-0.53-4.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update rudiments'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-a87ff17999
Comment 17 Fedora Update System 2015-11-13 00:29:02 EST
rudiments-0.53-4.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update rudiments'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-c816143d56
Comment 18 Fedora Update System 2016-07-25 21:18:40 EDT
rudiments-0.53-5.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-ea2cdb5b6b
Comment 19 Fedora Update System 2016-07-28 02:00:10 EDT
rudiments-0.53-5.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-ea2cdb5b6b
Comment 20 Fedora Update System 2016-12-24 22:20:52 EST
rudiments-0.53-5.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.